﻿//<debug />
//<assembly>API/ISD.CAD.IO.dll</assembly>
// <assembly>API/System.Data.dll</assembly>
// <assembly>API/ISD.CAD.Steel.dll</assembly>
// <assembly>ISD.PDM.API.dll</assembly>
// <assembly>Helios.API.dll</assembly>
// <assembly>API/ISD.CAD.Bridge.Helios.dll</assembly>
// <assembly>API/ISD.CAD.Data.dll</assembly>


using System;
using System.Windows;
using System.Windows.Controls;
using ISD.CAD.Data;
using ISD.CAD.Contexts;


//Script om BOM Relevantie van Helios Parts aan of uit te zetten.
//Bijwerking: Van alle niet Helios delen wordt de Bom relevantie uit gezet.
// Laatste modificatie 08-12-2016
// P. Versleijen

class Script : ISD.Scripting.ScriptBase
{
    [ISD.Scripting.Context(typeof(UnconstrainedContext))]

    public static void Main()
    {


        //=========================================================================================
        //Definieren van Window
        //=========================================================================================

        Window win = new Window();
        win.Title = "Bom Relevance On/Off ";
        win.Height = 160;					//Hoogte van Window
        win.Width = 300;					//Breedte van Window

        //Tabel (Grid) im Window
        Grid myGrid = new Grid();
        //myGrid.Height = 250; 										//Hoogte van tabel, nu niet gebruikt om dat elke regel een gedefineerde oogte heeft.
        //myGrid.Width = 250; 										//Breedte van kolommen, nu niet gebruikt om dat breedte van kolom apart gedefinieerd wordt.
        //myGrid.ShowGridLines = true;								//Rasterlijne aan of uit, makkelijk tijdens ontwerp

        // Columns in Tabel 
        myGrid.ColumnDefinitions.Add(new ColumnDefinition()); //00
        myGrid.ColumnDefinitions[0].Width = new GridLength(130);

        myGrid.ColumnDefinitions.Add(new ColumnDefinition()); //01
        myGrid.ColumnDefinitions[1].Width = new GridLength(25);

        myGrid.ColumnDefinitions.Add(new ColumnDefinition()); //02
        myGrid.ColumnDefinitions[2].Width = new GridLength(25);

        myGrid.ColumnDefinitions.Add(new ColumnDefinition()); //03
        myGrid.ColumnDefinitions[3].Width = new GridLength(100);


        // Regels (Rows) in Tabel
        myGrid.RowDefinitions.Add(new RowDefinition()); //00
        myGrid.RowDefinitions[0].Height = new GridLength(20);
        myGrid.HorizontalAlignment = HorizontalAlignment.Center;

        myGrid.RowDefinitions.Add(new RowDefinition()); //01
        myGrid.RowDefinitions[1].Height = new GridLength(20);

        myGrid.RowDefinitions.Add(new RowDefinition()); //02
        myGrid.RowDefinitions[2].Height = new GridLength(20);

        myGrid.RowDefinitions.Add(new RowDefinition()); //03
        myGrid.RowDefinitions[3].Height = new GridLength(30);

        myGrid.RowDefinitions.Add(new RowDefinition()); //04
        myGrid.RowDefinitions[4].Height = new GridLength(30);


        //=========================================================================================
        // Textblokken in de diverse regels
        //=========================================================================================

        TextBlock txt1 = new TextBlock();
        txt1.Text = "Entire Drawing";
        txt1.FontSize = 12;
        txt1.FontWeight = FontWeights.DemiBold;
       
        Grid.SetRow(txt1, 2);
        Grid.SetColumn(txt1, 0);
        myGrid.Children.Add(txt1);
        txt1.HorizontalAlignment = HorizontalAlignment.Right;

        TextBlock txt2 = new TextBlock();
        txt2.Text = "Active Part & Subparts";
        txt2.FontSize = 12;
        txt2.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt2, 1);
        Grid.SetColumn(txt2, 0);
        myGrid.Children.Add(txt2);
        txt2.HorizontalAlignment = HorizontalAlignment.Center;

        TextBlock txt3 = new TextBlock();
        txt3.Text = "On";
        txt3.FontSize = 12;
        txt3.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt3, 0);
        Grid.SetColumn(txt3, 1);
        myGrid.Children.Add(txt3);
        txt3.HorizontalAlignment = HorizontalAlignment.Center;


        TextBlock txt4 = new TextBlock();
        txt4.Text = "Off";
        txt4.FontSize = 12;
        txt4.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt4, 0);
        Grid.SetColumn(txt4, 2);
        myGrid.Children.Add(txt4);
        txt4.HorizontalAlignment = HorizontalAlignment.Center;


        //=========================================================================================
        //Checkboxen
        //=========================================================================================

        var checkbox1 = new RadioButton();
        Grid.SetRow(checkbox1, 1);
        Grid.SetColumn(checkbox1, 1);
        myGrid.Children.Add(checkbox1);
        checkbox1.HorizontalAlignment = HorizontalAlignment.Center;

        var checkbox2 = new RadioButton();
        Grid.SetRow(checkbox2, 1);
        Grid.SetColumn(checkbox2, 2);
        myGrid.Children.Add(checkbox2);
        checkbox2.HorizontalAlignment = HorizontalAlignment.Center;

        var checkbox3 = new RadioButton();
        Grid.SetRow(checkbox3, 2);
        Grid.SetColumn(checkbox3, 1);
        myGrid.Children.Add(checkbox3);
        checkbox3.HorizontalAlignment = HorizontalAlignment.Center;

        var checkbox4 = new RadioButton();
        Grid.SetRow(checkbox4, 2);
        Grid.SetColumn(checkbox4, 2);
        myGrid.Children.Add(checkbox4);
        checkbox4.HorizontalAlignment = HorizontalAlignment.Center;


        //=========================================================================================
        //Buttons
        //=========================================================================================

        //Button met "OK"
        Button btn1 = new Button();
        btn1.Content = "OK";
        btn1.Width = 80;
        btn1.Height = 25;
        btn1.FontSize = 12;
        Grid.SetRow(btn1, 3);
        Grid.SetColumn(btn1, 0);
        myGrid.Children.Add(btn1);
        btn1.Click += delegate (object sender, RoutedEventArgs e)
        {

            win.Close();  // Close Window
        };

        //Button met "Cancel"
        Button btn2 = new Button();
        btn2.Content = "Cancel";
        btn2.Width = 80;
        btn2.Height = 25;
        btn2.FontSize = 12;
        Grid.SetRow(btn2, 3);
        Grid.SetColumn(btn2, 3);
        myGrid.Children.Add(btn2);
        btn2.Click += delegate (object sender, RoutedEventArgs e)
        {
            //Uncheck the boxes if Cancel is pressed
            checkbox1.IsChecked = false;
            checkbox2.IsChecked = false;
            checkbox3.IsChecked = false;
            checkbox4.IsChecked = false;
            win.Close();						// Close Window
        };

        // Add the Grid as the Content of the Parent Window Object
        win.Content = myGrid;
        win.ShowDialog();

        // Controle op checkbox status en gewenste aktie in gang zetten.

        if (Convert.ToBoolean(checkbox1.IsChecked))
        {
            MessageBox.Show("Setting BOM Relevance 'ON' for active Part and Sub-parts");
            Part heliosPart = BomRelOnPart();

        }
        if (Convert.ToBoolean(checkbox2.IsChecked))
        {
            MessageBox.Show("Setting BOM Relevance 'OFF' for active Part and Sub-parts");
            Part heliosPart = BomRelOffPart();
        }

        if (Convert.ToBoolean(checkbox3.IsChecked))
        {
            MessageBox.Show("Setting BOM Relevance 'ON' for entire Drawing");
            Part heliosPart = BomRelOnScene();
        }
        if (Convert.ToBoolean(checkbox4.IsChecked))
        {
            MessageBox.Show("Setting BOM Relevance 'OFF' for entire Drawing");
            Part heliosPart = BomRelOffScene();
        }

    }

    private static Part BomRelOnPart() //Bom Relevantie aan, Part en subs mits Helios part.
    {
        try
        {
            foreach (Node n in Context.ActiveNode.NodeTree)

            {
                if (n.AttributeSet.Contains("$BK"))
                {
                    {
                        n.AttributeSet.SetValue("#SR", 1);
                    }
                }
                else
                {
                    n.AttributeSet.SetValue("#SR", 0);
                }

            }


            return null;
        }
        catch (System.Exception e)
        {
            MessageBox.Show("Oops, Crash!!");
            return null;
        }

    }


    private static Part BomRelOffPart() //Bom Relevantie uit, Part en subs mits Helios part
    {
        try
        {
            foreach (Node n in Context.ActiveNode.NodeTree)
            {
                if (n.AttributeSet.Contains("$BK"))
                {
                    {
                        n.AttributeSet.SetValue("#SR", 0);
                    }
                }
                else
                {
                    n.AttributeSet.SetValue("#SR", 0);
                }
            }
            return null;
        }
        catch (System.Exception e)
        {
            MessageBox.Show("Oops, Crash!!");
            return null;
        }
    }

    private static Part BomRelOnScene() //Bom Relevantie aan, gehele Scene, mits Helios part.
    {
        try
        {
            foreach (Node n in Context.ActiveScene.Nodes)
            {
                if (n.AttributeSet.Contains("$BK"))
                {
                    {
                        n.AttributeSet.SetValue("#SR", 1);
                    }
                }
                else
                {
                    n.AttributeSet.SetValue("#SR", 0);
                }

            }


            return null;
        }
        catch (System.Exception e)
        {
            MessageBox.Show("Oops, Crash!!");
            return null;
        }

    }


    private static Part BomRelOffScene() //Bom Relevantie uit, gehele Scene, mits Helios part
    {
        try
        {
            foreach (Node n in Context.ActiveScene.Nodes)
            {
                if (n.AttributeSet.Contains("$BK"))
                {
                    {
                        n.AttributeSet.SetValue("#SR", 0);
                    }
                }
                else
                {
                    n.AttributeSet.SetValue("#SR", 0);
                }
            }
            return null;
        }
        catch (System.Exception e)
        {
            MessageBox.Show("Oops, Crash!!");
            return null;
        }
    }

    //end of the show, have a nice day!!

    public static UnconstrainedContext Context
    {
        get { return BaseContext as UnconstrainedContext; }
    }
}
